#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;


int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int cnt_swap = atoi(argv[1]);

	int n;	
	scanf("%d", &n);
	vector<int> p(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &p[i]);
	}
	
	for (int i = 0; i < cnt_swap; ++i)
	{
		int l = rnd.next(0, n - 1);
		int r = rnd.next(0, n - 1);
		swap(p[l], p[r]);
	}

	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
	{
		printf("%d%c", p[i], " \n"[i == n - 1]);
	}

	return 0;
}


