#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

void postShuffle(vector<pair<int, int> > &edges)
{
	int n = (int)edges.size() + 1;
	vector<int> perm;
	for (int i = 0; i <= n; i++)
	{
		perm.push_back(i);
	}
//	shuffle(perm.begin() + 1, perm.end());
	for (int i = 0; i < (int)edges.size(); i++)
	{
		edges[i].first = perm[edges[i].first];
		edges[i].second = perm[edges[i].second];
		if (rnd.next(0, 1) == 1)
		{
			swap(edges[i].first, edges[i].second);
		}
	}
	shuffle(edges.begin(), edges.end());
}
const int MAXN = 500 * 1000 + 7;
int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	vector<pair<int, int> > edges;
	int nextId = 2;
	queue<int> q;
	q.push(1);
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int i = 1; i <= k; i++)
		{
			if (nextId <= n)
			{
				edges.push_back(make_pair(v, nextId));
				q.push(nextId);
				nextId++;
			}
		}
	}	
	postShuffle(edges);
	printf("%d\n", n);
	for (int i = 0; i < n - 1; i++)
	{
		printf("%d %d\n", edges[i].first, edges[i].second);
	}
	return 0;
}
