#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int MAX_N = 100 * 1000;

int n, m, sz[MAX_N];
vector<int> a[MAX_N];
bool big[MAX_N];

void readInput() {
    n = inf.readInt();
    m = inf.readInt();
    for (int i = 0; i < n; i++) {
        sz[i] = inf.readInt();
        a[i].resize(sz[i]);
        for (int j = 0; j < sz[i]; j++) {
            a[i][j] = inf.readInt(1, m);
            a[i][j]--;
        }
    }
}

bool cmp(int a, int b) {
    if (big[a] == big[b]) {
        return a < b;
    } else {
        return big[a];
    }
}

bool readAns(InStream &ans) {
    for (int i = 0; i < m; i++) {
        big[i] = false;
    }
    string answer = ans.readString();
    if (answer == "No") {
        return false;
    } else if (answer != "Yes") {
        ans.quitf(_pe, "answer != Yes && answer != No");
    }
    int siz = ans.readInt(0, MAX_N);
    for (int i = 0; i < siz; i++) {
        int ind = ans.readInt(1, m);
        ind--;
        if (big[ind]) {
            ans.quitf(_pe, "Printed same symbol multiple times");
        }
        big[ind] = true;
    }
    for (int i = 1; i < n; i++) {
        int len = min(sz[i - 1], sz[i]);
        bool f = false;
        for (int j = 0; j < len; j++) {
            if (a[i - 1][j] == a[i][j]) continue;
            f = true;
            if (!cmp(a[i - 1][j], a[i][j])) {
                ans.quitf(_wa, "Strings are not sorted");
            }
            break;
        }
        if (!f && sz[i - 1] > sz[i]) {
            ans.quitf(_wa, "Strings are not sorted!!!");
        }
    }
    return true;
}

int main(int argc, char * argv[])
{
    setName("Check if configuration of big symbols make strings sorted");
    registerTestlibCmd(argc, argv);
    readInput();
    bool answ = readAns(ans);
    bool cont = readAns(ouf);
    if (cont == answ) {
        quitf(_ok, "The answers are similar");
    } else if (cont) {
        quitf(_fail, "Contestant found the answer, but we didnt");
    } else if (answ) {
        quitf(_wa, "Contestand didnt found the answer, but we did");
    }
    quitf(_ok, "%d numbers", n);
}