#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
ostream& operator << (ostream& cout, const vector<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "()");
    }
    cout << "(" << a[0];
    for (int i = 1; i < (int)a.size(); i++) {
    	cout << "; " << a[i];
    }
    return (cout << ")");
}

template<typename T>
ostream& operator << (ostream& cout, const set<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "{}");
    }
    auto it = a.begin();
    cout << "{" << *it;
    ++it;
    for (; it != a.end(); ++it) {
    	cout << "; " << *it;
    }
    return (cout << "}");
}

template<typename T>
ostream& operator << (ostream& cout, const multiset<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "{}");
    }
    auto it = a.begin();
    cout << "{" << *it;
    ++it;
    for (; it != a.end(); ++it) {
    	cout << "; " << *it;
    }
    return (cout << "}");
}

template<typename T1, typename T2>
ostream& operator << (ostream& cout, const pair<T1, T2> &a) {
    return cout << "(" << a.first << "; " << a.second << ")";
}

random_device gen;
mt19937 rnd(gen());

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

bool big[nmax];
int sz[nmax];
vector<int> a[nmax];

bool cmp(int a, int b) {
    if (big[a] != big[b]) {
        return big[a];
    } else {
        return a <= b;
    }
}

int main() {
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    //freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        scanf("%d", &sz[i]);
        a[i].resize(sz[i]);
        for (int j = 0; j < sz[i]; j++) {
            scanf("%d", &a[i][j]);
            a[i][j]--;
        }
    }
    for (int i = n - 1; i > 0; i--) {
        int len = min(sz[i], sz[i - 1]);
        bool f = false;
        for (int j = 0; j < len; j++) {
            if (a[i - 1][j] == a[i][j]) continue;
            f = true;
            if (!cmp(a[i - 1][j], a[i][j])) {
                big[a[i - 1][j]] = true;
            }
            break;
        }
        if (!f && sz[i - 1] > sz[i]) {
            printf("No\n");
            return 0;
        }
    }
    for (int i = 1; i < n; i++) {
        int len = min(sz[i - 1], sz[i]);
        for (int j = 0; j < len; j++) {
            if (a[i][j] == a[i - 1][j]) continue;
            if (!cmp(a[i - 1][j], a[i][j])) {
                printf("No\n");
                return 0;
            }
            break;
        }
    }
    printf("Yes\n");
    vector<int> ans;
    for (int i = 0; i < m; i++) {
        if (big[i]) {
            ans.pb(i);
        }
    }
    printf("%d\n", (int)ans.size());
    for (int u : ans) {
        printf("%d ", u + 1);
    }
    return 0;
}
