#include "testlib.h"
#include <bits/stdc++.h> 
#include <vector>
#include <map>

using namespace std;
long long const MAX = 1000 * 1000 * 1000;
long long n, m, k;
map<int, int> a;

long long readAns(InStream &stream) {
    string yesno = stream.readToken("Yes|No");
	if (yesno == "No")
		return false;
	long long y,x;
	map<int, int> b = a;
	for (int i = 0; i<k; i++)
	{
		long long x = stream.readLong(0, MAX, "b_i");
		if (b[x]==0)
			stream.quitf(_wa, "These numbers are not enough for your answer");
		b[x]--;
		if (i>0 && (x-y)%m!=0)
			stream.quitf(_wa, "%%lld-%%lld=%%lld not divided into m=%%lld", y, x, y-x, m);
		y = x;
	}

	return true;
}

int main(int argc, char* argv[]) {
	int x;
	registerTestlibCmd(argc, argv);

	n = inf.readLong();
	k = inf.readLong();
	m = inf.readLong();
	for (int i = 1; i <= n; i++) {
		x = inf.readLong();
		a[x]++;
	}
	
	long long jans = readAns(ans);
	long long pans = readAns(ouf);

	if (jans > pans)
		quitf(_wa, "The answer exists");

	if (jans < pans)
		quitf(_fail, "The jury did not find the answer");

	if (jans)
			quitf(_ok, "Solution exists");
		else
			quitf(_ok, "No solution");
}