#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
ostream& operator << (ostream& cout, const vector<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "()");
    }
    cout << "(" << a[0];
    for (int i = 1; i < (int)a.size(); i++) {
    	cout << "; " << a[i];
    }
    return (cout << ")");
}

template<typename T>
ostream& operator << (ostream& cout, const set<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "{}");
    }
    auto it = a.begin();
    cout << "{" << *it;
    ++it;
    for (; it != a.end(); ++it) {
    	cout << "; " << *it;
    }
    return (cout << "}");
}

template<typename T>
ostream& operator << (ostream& cout, const multiset<T> &a) {
    if ((int)a.size() == 0) {
    	return (cout << "{}");
    }
    auto it = a.begin();
    cout << "{" << *it;
    ++it;
    for (; it != a.end(); ++it) {
    	cout << "; " << *it;
    }
    return (cout << "}");
}

template<typename T1, typename T2>
ostream& operator << (ostream& cout, const pair<T1, T2> &a) {
    return cout << "(" << a.first << "; " << a.second << ")";
}

random_device gen;
mt19937 rnd(gen());

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

int n;
string s;
bool canr[nmax], canb[nmax], can[nmax];

int main() {
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    //freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    cin >> n;
    getline(cin, s);
    getline(cin, s);
    if (s[0] == 'r') {
        canb[0] = 0;
        canr[0] = 1;
    } else if (s[0] == 'b') {
        canr[0] = 0;
        canb[0] = 1;
    } else {
        canr[0] = canb[0] = 1;
    }
    for (int i = 1; i < n; i++) {
        if (s[i] == 'r') {
            canb[i] = 0;
            canr[i] = canr[i - 1];
        } else if (s[i] == 'b') {
            canr[i] = 0;
            canb[i] = canb[i - 1];
        } else {
            canb[i] = canb[i - 1];
            canr[i] = canr[i - 1];
        }
    }
    can[n] = 1;
    for (int i = n - 1; i >= 0; i--) {
        can[i] = can[i + 1] & (s[i] == '?' || s[i] == (((n - i) & 1) ? 'b' : 'r'));
    }
    int answer = 0;
    if (can[0]) {
        answer++;
    }
    for (int i = 1; i <= n; i++) {
        if (can[i] && (n - i) % 2 == 0 && canr[i - 1]) {
            answer++;
        }
        if (can[i] && (n - i) % 2 == 1 && canb[i - 1]) {
            answer++;
        }
    }
    cout << answer << endl;
    return 0;
}
