#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

const int MAXN = 200003;

const int L = 26;

vector <int> e[MAXN];
int c[MAXN];
vector <int> cap;

void nein() {
    cout << "Impossible\n";
    exit(0);
}

void cp(int x) {
    if (c[x] == -1) {
        nein();
    }

    if (c[x] == 0) {
        cap.push_back(x);
        c[x] = 1;
    }
}

void noncp(int x) {
    if (c[x] == 1) {
        nein();
    }

    c[x] = -1;
}

void dfs(int x) {
    if (c[x] == 1) {
        c[x] = 2;
        for (int u : e[x]) {
            cp(u);
            dfs(u);
        }
    }
}

vector <int> rd() {
    int n;
    cin >> n;
    vector <int> ans(n);
    for (int& x : ans) {
        cin >> x;
    }
    return ans;
}

int main() {
#ifdef PAUNSVOKNO
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20);
    int n;
    cin >> n;
    int red = 0, blue = 0;
    string s;
    cin >> s;
    for (int i = n - 1; i >= 0; i--) {
        int sm = i / 2;
        int bg = (i + 1) / 2;
        if (s[n - 1 - i] == 'b') {
            if (i % 2 == 0) {
                blue = max(blue, sm + 1);
            } else {
                blue = max(blue, n - sm);
            }
        } else if (s[n - 1 - i] == 'r') {
            if (i % 2 == 1) {
                red = max(red, bg);
            } else {
                red = max(red, n - bg);
            }
        }
    }
    cout << max(0, n - red - blue + 1) << "\n";
}
