#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

int find(string& s, char c) {
	int result = -1;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == c) {
			result = i;
		}
	}
	return result;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	string row;
	int n;
	cin >> n;
	cin >> row;

	reverse(row.begin(), row.end());
	int most_right_r = find(row, 'r');
	int most_right_b = find(row, 'b');

	int result = 0;

	for (int prefix = 0; prefix <= row.size(); prefix += 2)
	{
		if (prefix > 0) {
			if (row[prefix - 1] == 'b' || row[prefix - 2] == 'r') {
				break;
			}
		}
		if (most_right_b < prefix || most_right_r < prefix) {
			result += 1;
			if (most_right_b < prefix  && most_right_r < prefix && prefix < row.size()) {
				result += 1;
			}
		}
	}
	cout << result;

}