#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;


int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int on_front = atoi(argv[1]);
	int on_back = atoi(argv[2]);
	int shuffle_front = atoi(argv[3]);
	int shuffle_back = atoi(argv[4]);

	int n;	
	scanf("%d", &n);
	vector<int> p(n);
	vector<int> to_front;
	vector<int> to_back;
	vector<int> other;
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &p[i]);
		if (p[i] <= on_front)
		{
			to_front.push_back(p[i]);
		}
		else if (p[i] > n - on_back)
		{
			to_back.push_back(p[i]);
		}
		else
		{
			other.push_back(p[i]);
		}
	}

	p.clear();
	if (shuffle_front)
	{
		shuffle(to_front.begin(), to_front.end());
	}
	if (shuffle_back)
	{
		shuffle(to_back.begin(), to_back.end());
	}

	for (int i = 0; i < (int)to_front.size(); ++i)
	{
		p.push_back(to_front[i]);
	}
	for (int i = 0; i < (int)to_back.size(); ++i)
	{
		p.push_back(to_back[i]);
	}
	for (int i = 0; i < (int)other.size(); ++i)
	{
		p.push_back(other[i]);
	}

	
	assert((int)p.size() == n);
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
	{
		printf("%d%c", p[i], " \n"[i == n - 1]);
	}

	return 0;
}


