#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;


int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int min_len = atoi(argv[2]);
	int max_len = atoi(argv[3]);
	int min_bet = atoi(argv[4]);
	int max_bet = atoi(argv[5]);
	int sorted = atoi(argv[6]);

	vector<int> intervals;
	vector<int> other;

	int ptr = 0;

	
	while (ptr < n)
	{
		int new_len = min(n - ptr, rnd.next(min_len, max_len));
		int new_bet = min(n - ptr - new_len, rnd.next(min_bet, max_bet));

		for (int mem = ptr + new_len; ptr < mem; ++ptr)
		{
			intervals.push_back(ptr);
		}
		for (int mem = ptr + new_bet; ptr < mem; ++ptr)
		{
			other.push_back(ptr);
		}
	}

	shuffle(intervals.begin(), intervals.end());
	
	if (sorted == 0)
	{
		shuffle(other.begin(), other.end());
	}
	else if (sorted == 1)
	{
		sort(other.begin(), other.end());
	}
	else
	{
		sort(other.begin(), other.end());
		reverse(other.begin(), other.end());
	}

	vector<int> p;
	for (int i = 0; i < (int)intervals.size(); ++i)
	{
		p.push_back(intervals[i] + 1);
	}
	for (int i = 0; i < (int)other.size(); ++i)
	{
		p.push_back(other[i] + 1);
	}
	
	assert((int)p.size() == n);
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
	{
		printf("%d%c", p[i], " \n"[i == n - 1]);
	}

	return 0;
}


