#include "testlib.h"
#include <algorithm>
#include <vector>

using namespace std;

const int MAX_N = 300 * 1000;

int main(int argc, char **argv)
{
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAX_N, "n");
	inf.readEoln();
	
	vector<int> p(n);
	for (int i = 0; i < n; ++i)
	{
		p[i] = inf.readInt(1, n, "p_" + vtos(i + 1));
		if (i == n - 1)
		{
			inf.readEoln();
		}
		else
		{
			inf.readSpace();
		}
	}
	
	sort(p.begin(), p.end());
	for (int i = 0; i < n; ++i)
	{
		ensuref(p[i] == i + 1, "p must be a permutation");
	}

	inf.readEof();

	return 0;
}

