#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>
#include <numeric>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;


const int MAX_N = 300 * 1000 + 5;
const int MAGIC = 10000;

int n;
int p[MAX_N];
bitset<MAGIC> arr[(MAX_N + MAGIC - 1) / MAGIC];

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d", &n);
	for (int i = 0; i < n; ++i) 
	{
		scanf("%d", &p[i]);
		p[i] = n - p[i];
	}
	
	int cnt_blk = (n + MAGIC - 1) / MAGIC;
	int last_sz = n % MAGIC;
	if (last_sz == 0) last_sz = MAGIC;

	for (int i = 0; i < cnt_blk; ++i)
	{
		for (int j = 0; j < MAGIC; ++j)
		{
			if (i * MAGIC + j < n)
			{
				arr[i][j] = 1;
			}
		}
	}
	
	int last = 0;
	for (int it = 0; it < n; ++it)
	{
		while (last < cnt_blk && !arr[last].count()) ++last;
		int ptr = arr[last]._Find_first();
		int sz = last == cnt_blk - 1 ? last_sz : MAGIC;
		int ans = (sz - ptr) - (arr[last] >> ptr).count(); 
		for (int i = last + 1; i < cnt_blk; ++i)
			ans += (i == cnt_blk - 1 ? last_sz : MAGIC) - arr[i].count();

		printf("%d ", ans + 1);
		arr[p[it] / MAGIC][p[it] % MAGIC] = 0;
	}

	printf("1\n");

	return 0;
}


