#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;


const int MAX_N = 300 * 1000 + 5;

int n;
int p[MAX_N];
int f[MAX_N];
set<int> zero;

int get(int x)
{
	int ans = 0;
	for (; x > -1; x = (x & (x + 1)) - 1)
		ans += f[x];
	return ans;
}

void upd(int x)
{
	for (; x < n; x = (x | (x + 1)))
		f[x] += 1;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d", &n);
	for (int i = 0; i < n; ++i) 
	{
		scanf("%d", &p[i]);
		--p[i];
	}

	memset(f, 0, sizeof(f));
	for (int i = 0; i < n; ++i) zero.insert(i);

	for (int it = 0; it < n; ++it)
	{
		printf("%d ", get(*zero.rbegin()) + 1);
		upd(p[it]);
		zero.erase(p[it]);
	}

	printf("1\n");

	return 0;
}

