#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

void postShuffle(vector<pair<int, int> > &edges)
{
	int n = (int)edges.size() + 1;
	vector<int> perm;
	for (int i = 0; i <= n; i++)
	{
		perm.push_back(i);
	}
//	shuffle(perm.begin() + 1, perm.end());
	for (int i = 0; i < (int)edges.size(); i++)
	{
		edges[i].first = perm[edges[i].first];
		edges[i].second = perm[edges[i].second];
		if (rnd.next(0, 1) == 1)
		{
			swap(edges[i].first, edges[i].second);
		}
	}
	shuffle(edges.begin(), edges.end());
}
int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	vector<pair<int, int> > edges;
	vector<int> bamboo;
	int nextId = 1;
	while (true)
	{
		if (!bamboo.empty())
		{
			edges.push_back(make_pair(bamboo.back(), nextId));
		}
		bamboo.push_back(nextId);
		nextId++;
		for (int i = 1; i < (int)bamboo.size(); i++)
		{
			if (nextId > n) break;
			edges.push_back(make_pair(nextId - 1, nextId));
			nextId++;
		}
		if (nextId > n) break;
	}
	postShuffle(edges);
	printf("%d\n", n);
	for (int i = 0; i < n - 1; i++)
	{
		printf("%d %d\n", edges[i].first, edges[i].second);
	}
	return 0;
}
