#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 228;

struct edge
{
	ll v;
	ll fr;
	ll bk;
	ll number;
};

int n;
vector<edge> g[MAX_N];
bool used[2 * MAX_N];
ll ans = -LLINF;
ll cur = 0;

void dfs(int v)
{
	if (v == n - 1) ans = max(ans, cur);
	
	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		if (used[g[v][i].number]) continue;
		used[g[v][i].number] = true;
		cur += g[v][i].fr;
		dfs(g[v][i].v);
		cur -= g[v][i].fr;
		used[g[v][i].number] = false;
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif 	

	scanf("%d", &n);
	for (int i = 0; i < n - 1; ++i)
	{
		int v, u;
		ll c1, c2;
		scanf("%d%d%lld%lld", &v, &u, &c1, &c2);
		--v; --u;
		g[v].push_back({(ll)u, c1, c2, 2ll * i});
		g[u].push_back({(ll)v, c2, c1, 2ll * i + 1});
	}
	
	dfs(0);
	printf("%lld\n", ans);

	return 0;
}

