#include <bits/stdc++.h>

using namespace std;

const int MX = 100 * 1000 + 7;

vector<pair<int, int> > g[MX], g2[MX];
long long dp[MX];
bool path[MX];

long long dfs(int v, int t, int p = -1) {
	long long res = -1;
	for (int i = 0; i < g[v].size(); i++) {
		if (g[v][i].first == p) continue;
		long long tmp = dfs(g[v][i].first, t, v);
		if (tmp != -1) {
			res = tmp + g[v][i].second;
		} else {
			dp[v] += max(0ll, dp[g[v][i].first] + g2[v][i].second);
		}
	}
	if (v == t) res = 0;
	if (res != -1) {
		path[v] = true;
		res += dp[v];
	}
	return res;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
	int n;
	scanf("%d", &n);
	for (int i = 1; i < n; i++) {
		int u, v, p, q;
		scanf("%d %d %d %d", &u, &v, &p, &q);
		g[u].emplace_back(v, p);
		g[v].emplace_back(u, q);
		g2[u].emplace_back(v, p + q);
		g2[v].emplace_back(u, p + q);
	}
	long long res = dfs(1, n);
	printf("%lld\n", res);
	return 0;
}
