#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc != 5) {
        cerr << "Usage: n, maxlen, maxchar, seed" << endl;
        return 1;
    } 
    int n = atoi(argv[1]);
    int maxlen = atoi(argv[2]);
    int maxc = atoi(argv[3]);

    cout << n << " " << maxc << endl;
    for (int i = 0; i < n; i++) {
        int len = rnd.next(1, maxlen);
        cout << len;
        for (int j = 0; j < len; j++)
            cout << " " << rnd.next(1, maxc);
        cout << endl;
    }

    return 0;
}
