#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 5;

int n, m;
vector<int> arr[MAX_N];
int pr[MAX_N];
int rg[MAX_N];
bool sm[MAX_N];
bool bg[MAX_N];
vector<int> ans;

int get(int v)
{
	return v == pr[v] ? v : pr[v] = get(pr[v]);
}

void un(int v1, int v2)
{
	v1 = get(v1);
	v2 = get(v2);

	if (v1 != v2)
	{
		if (rg[v1] < rg[v2]) swap(v1, v2);
		if (rg[v1] == rg[v2]) ++rg[v1];
		pr[v2] = v1;
		bg[v1] |= bg[v2];
		sm[v1] |= sm[v2];
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d%d", &n, &m);

	for (int i = 0; i < n; ++i)
	{
		int sz;
		scanf("%d", &sz);
		arr[i].resize(sz);
		for (int j = 0; j < sz; ++j)
		{
			scanf("%d", &arr[i][j]);
			--arr[i][j];
		}
	}
	
	for (int i = 0; i < m; ++i)
	{
		pr[i] = i;
		rg[i] = 0;
		bg[i] = sm[i] = false;
	}

	for (int i = 0; i < n - 1; ++i)
	{
		for (int j = 0; j < (int)arr[i].size(); ++j)
		{
			if (j >= (int)arr[i + 1].size())
				return 0 * printf("No\n");
			
			if (arr[i][j] == arr[i + 1][j])
				continue;

			if (arr[i][j] < arr[i + 1][j])
			{
				un(arr[i][j], arr[i + 1][j]);
			}
			else if (arr[i][j] > arr[i + 1][j])
			{
				bg[get(arr[i][j])] = true;
				sm[get(arr[i + 1][j])] = true;
			}
			break;
		}
	}

	for (int i = 0; i < m; ++i)
	{
		if (sm[get(i)] && bg[get(i)])
			return 0 * printf("No\n");
		
		if (bg[get(i)])
			ans.push_back(i);
	}

	printf("Yes\n");
	printf("%d\n", (int)ans.size());
	for (int i = 0; i < (int)ans.size(); ++i)
	{
		printf("%d%c", ans[i] + 1, " \n"[i == (int)ans.size() - 1]);
	}

	return 0;
}

