#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 5;

int n, m;
vector<int> arr[MAX_N];
vector<int> ans;
bool bg[MAX_N];
bool sm[MAX_N];
bool g_bg[MAX_N];

vector<pair<int, int>> to_cmp;

bool bad()
{
	for (int i = 0; i < (int)to_cmp.size(); ++i)
	{
		if (g_bg[to_cmp[i].first] != g_bg[to_cmp[i].second] && 
			g_bg[to_cmp[i].second])
		{
			if (sm[to_cmp[i].first])
			{
				if (!bg[to_cmp[i].second])
				{
					g_bg[to_cmp[i].second] = false;
					sm[to_cmp[i].second] = true;
					swap(to_cmp[i], to_cmp.back());
					to_cmp.pop_back();
				}
			}
			else if (bg[to_cmp[i].second])
			{
				g_bg[to_cmp[i].first] = true;
				bg[to_cmp[i].first] = true;
				swap(to_cmp[i], to_cmp.back());
				to_cmp.pop_back();
			}
			else
			{
				if (rand() % 2)
					g_bg[to_cmp[i].first] ^= 1;
				else
					g_bg[to_cmp[i].second] ^= 1;
			}
			return true;
		}
	}

	return false;;
}

bool TL()
{
	return clock() * 100 >= 95 * CLOCKS_PER_SEC;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d%d", &n, &m);

	for (int i = 0; i < n; ++i)
	{
		int sz;
		scanf("%d", &sz);
		arr[i].resize(sz);
		for (int j = 0; j < sz; ++j)
		{
			scanf("%d", &arr[i][j]);
			--arr[i][j];
		}
	}
	
	memset(g_bg, 0, sizeof(g_bg));
	memset(bg, 0, sizeof(bg));
	memset(sm, 0, sizeof(sm));
	for (int i = 0; i < n - 1; ++i)
	{
		for (int j = 0; j < (int)arr[i].size(); ++j)
		{
			if (j >= (int)arr[i + 1].size())
				return 0 * printf("No\n");
			
			if (arr[i][j] == arr[i + 1][j])
				continue;
			
			
			if (arr[i][j] > arr[i + 1][j])
			{
				g_bg[arr[i][j]] = true;
				bg[arr[i][j]] = true;
				sm[arr[i + 1][j]] = true;
			}
			else
				to_cmp.push_back({arr[i][j], arr[i + 1][j]});
			break;
		}
	}

	for (int i = 0; i < m; ++i)
	{
		if (sm[i] && bg[i])
			return 0 * printf("No\n");
	}

	for (int i = 0; i < (int)to_cmp.size(); ++i)
	{
		if (sm[to_cmp[i].first] || bg[to_cmp[i].first])
		{
			if (sm[to_cmp[i].second] || bg[to_cmp[i].second])
			{
				if (bg[to_cmp[i].first]) to_cmp[i].first -= 2 * m;
				if (bg[to_cmp[i].second]) to_cmp[i].second -= 2 * m;

				if (to_cmp[i].first > to_cmp[i].second)
					return 0 * printf("No\n");
				
				swap(to_cmp[i], to_cmp.back());
				to_cmp.pop_back();
				--i;
			}
		}
	}
	
	while (!TL() && bad());

	if (bad())
		return 0 * printf("No\n");
	
	for (int i = 0; i < m; ++i)
	{
		if (g_bg[i])
			ans.push_back(i);
	}

	printf("Yes\n");
	printf("%d\n", (int)ans.size());
	for (int i = 0; i < (int)ans.size(); ++i)
	{
		printf("%d%c", ans[i] + 1, " \n"[i == (int)ans.size() - 1]);
	}

	return 0;
}

