#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 5;

int n, m;
vector<int> arr[MAX_N];
vector<int> ans;
vector<int> g[MAX_N];
bool bg[MAX_N];
bool sm[MAX_N];
bool used[MAX_N];

void dfs(int v)
{
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		if (!used[g[v][i]]) dfs(g[v][i]);
		bg[v] |= bg[g[v][i]];
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d%d", &n, &m);

	for (int i = 0; i < n; ++i)
	{
		int sz;
		scanf("%d", &sz);
		arr[i].resize(sz);
		for (int j = 0; j < sz; ++j)
		{
			scanf("%d", &arr[i][j]);
			--arr[i][j];
		}
	}
	
	memset(used, 0, sizeof(used));
	memset(bg, 0, sizeof(bg));
	memset(sm, 0, sizeof(sm));
	for (int i = 0; i < n - 1; ++i)
	{
		if (arr[i] == arr[i + 1])
			return 0 * printf("Kek\n");
		for (int j = 0; j < (int)arr[i].size(); ++j)
		{
			if (j >= (int)arr[i + 1].size())
				return 0 * printf("No\n");
			
			if (arr[i][j] == arr[i + 1][j])
				continue;
			
			if (arr[i][j] < arr[i + 1][j])
			{
				g[arr[i][j]].push_back(arr[i + 1][j]);
			}
			else if (arr[i][j] > arr[i + 1][j])
			{
				bg[arr[i][j]] = true;
				sm[arr[i + 1][j]] = true;
			}
			break;
		}
	}
	
	for (int i = 0; i < m; ++i)
	{
		if (!used[i]) dfs(i);
		if (sm[i] && bg[i])
			return 0 * printf("No\n");
		
		if (bg[i])
			ans.push_back(i);
	}
	
	printf("Yes\n");
	printf("%d\n", (int)ans.size());
	for (int i = 0; i < (int)ans.size(); ++i)
	{
		printf("%d%c", ans[i] + 1, " \n"[i == (int)ans.size() - 1]);
	}

	return 0;
}


