#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

const int MAXN = 200003;

const int L = 26;

vector <int> e[MAXN];
int c[MAXN];
vector <int> cap;

void nein() {
    cout << "No\n";
    exit(0);
}

void cp(int x) {
    if (c[x] == -1) {
        nein();
    }

    if (c[x] == 0) {
        cap.push_back(x);
        c[x] = 1;
    }
}

void noncp(int x) {
    if (c[x] == 1) {
        nein();
    }

    c[x] = -1;
}

void dfs(int x) {
    if (c[x] == 1) {
        c[x] = 2;
        for (int u : e[x]) {
            cp(u);
            dfs(u);
        }
    }
}

vector <int> rd() {
    int n;
    cin >> n;
    vector <int> ans(n);
    for (int& x : ans) {
        cin >> x;
    }
    return ans;
}

int main() {
#ifdef PAUNSVOKNO
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20);
    int n, m;
    cin >> n >> m;
    vector <int> p = rd();
    for (int j = 1; j < n; j++) {
        vector <int> cur = rd();
        bool df = false;
        for (int i = 0; i < min(cur.size(), p.size()); ++i) {
            if (p[i] < cur[i]) {
                e[cur[i]].push_back(p[i]);
                df = true;
                break;
            }

            if (p[i] > cur[i]) {
                cp(p[i]);
                noncp(cur[i]);
                df = true;
                break;
            }
        }
        if (!df) {
            if (p.size() > cur.size()) {
                nein();
            }
        }

        p = move(cur);
    }

    for (int i = 1; i <= m; i++) {
        dfs(i);
    }

    cout << "Yes\n" << cap.size() << "\n";
    for (int x : cap) {
        cout << x << "\n";
    }
}
